macro 30l FROM ALL {
  str port_io_code[10];
  int i;

  if( (video_card != 7 ) && (video_card !=  8) ) goto _cancel;
  if( screen_length == 30 ) goto _cancel;

  set_video_mode(1);
  if( video_mode != 1 ) goto _cancel;

  R_AX = 0x83; intr(0x10);

  R_DX = 0x3C4;
  R_AX = 0x100; call _outw;
  R_AX = 0x001; call _outw;
  R_AX = 0x302; call _outw;
  R_AX = 0x003; call _outw;
  R_AX = 0x204; call _outw;

  R_DX = 0x3C2;
  R_AX = 0xE7;  call _outb;

  R_DX = 0x3C4;
  R_AX = 0x300; call _outw;

  R_DX = 0x3D4;
  R_AX = 0x0C11; call _outw;
  R_AX = 0x0B06; call _outw;
  R_AX = 0x3E07; call _outw;
  R_AX = 0x4F09; call _outw;
  R_AX = 0xEA10; call _outw;
  R_AX = 0x8C11; call _outw;
  R_AX = 0xDF12; call _outw;
  R_AX = 0xE715; call _outw;
  R_AX = 0x0416; call _outw;

  poke(0, 0x484, 29);
  poke(0, 0x487, peek(0, 0x487) & 0xFFFE);

  goto _end;

_inb:
  port_io_code = '2';     /*  in al,dx // xor ah,ah // iret  */
  goto _do_out;
_inw:
  port_io_code = '';       /*  in ax,dx // iret  */
  goto _do_out;
_outb:
  port_io_code = '';       /*  out dx,al // iret  */
  goto _do_out;
_outw:
  port_io_code = '';       /*  out dx,ax // iret  */
_do_out:
  for( i = 0x60; Memp(i << 2) && (i < 0xFD);  i++)  /*  Find an unused user interrupt  */
  if( i == 0xFD  ) ret;
  Memp(i << 2, Seg (port_io_code) << 16 + Ofs (port_io_code) + 4); /*  Set interrupt vector  */
  Intr (i);
  Return_Int = R_AX;
  Return_Str = '';
  Memp (i << 2, 0);  /*  Clear interrupt table entry  */
  ret;

_end:
  screen_length = 30;
  rm('SetScrn');

_cancel:
}
